Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3864)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implemented nesting for salsa variables.
+! 
+! 3833 2019-03-28 15:04:04Z forkel
 ! replaced USE chem_modules by USE chem_gasphase_mod 
 ! 
@@ -398,5 +401,5 @@
                coupling_char, dt_3d, dz, humidity, message_string,             &
                neutral, passive_scalar, rans_mode, rans_tke_e,                 &
-               roughness_length, topography, volume_flow
+               roughness_length, salsa, topography, volume_flow
 
     USE chem_gasphase_mod,                                                          &
@@ -457,4 +460,9 @@
 
 #endif
+   
+    USE salsa_mod,                                                             &
+        ONLY:  aerosol_mass, aerosol_number, gconc_2, mconc_2, nbins_aerosol,  &
+               ncomponents_mass, nconc_2, nest_salsa, ngases_salsa, salsa_gas, &
+               salsa_gases_from_chem
 
     USE surface_mod,                                                           &
@@ -518,5 +526,9 @@
     INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  part_adrc   !<
 
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< Parent-grid array on child domain - chemical species
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< coarse grid array on child domain - chemical species
+
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_mass_c   !< aerosol mass
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_number_c !< aerosol number 
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  salsa_gas_c      !<  salsa gases
 !
 !-- Grid-spacing ratios.
@@ -817,18 +829,22 @@
 
     CHARACTER(LEN=32) ::  myname
-    
-    INTEGER(iwp) ::  child_id           !<
-    INTEGER(iwp) ::  ierr               !<
-    INTEGER(iwp) ::  k                  !<
-    INTEGER(iwp) ::  m                  !<
-    INTEGER(iwp) ::  mid                !<
-    INTEGER(iwp) ::  mm                 !<
-    INTEGER(iwp) ::  n = 1              !< Running index for chemical species
-    INTEGER(iwp) ::  nest_overlap       !<
-    INTEGER(iwp) ::  nomatch            !<
-    INTEGER(iwp) ::  nx_cl              !<
-    INTEGER(iwp) ::  ny_cl              !<
-    INTEGER(iwp) ::  nz_cl              !<
-    INTEGER(iwp), DIMENSION(3) ::  val  !< Array for receiving the child-grid dimensions
+    INTEGER(iwp) ::  child_id         !<
+    INTEGER(iwp) ::  ib = 1           !< running index for aerosol size bins
+    INTEGER(iwp) ::  ic = 1           !< running index for aerosol mass bins
+    INTEGER(iwp) ::  ig = 1           !< running index for salsa gases
+    INTEGER(iwp) ::  ierr             !<
+    INTEGER(iwp) ::  k                !<
+    INTEGER(iwp) ::  m                !<
+    INTEGER(iwp) ::  mid              !<
+    INTEGER(iwp) ::  mm               !<
+    INTEGER(iwp) ::  n = 1            !< running index for chemical species
+    INTEGER(iwp) ::  nest_overlap     !<
+    INTEGER(iwp) ::  nomatch          !<
+    INTEGER(iwp) ::  nx_cl            !<
+    INTEGER(iwp) ::  ny_cl            !<
+    INTEGER(iwp) ::  nz_cl            !<
+
+    INTEGER(iwp), DIMENSION(5) ::  val    !<
+
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xl   !<
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xr   !<    
@@ -1032,5 +1048,19 @@
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
                                           nz_cl = nz_cl, n = n )
-             n = n + 1
+             n = n + 1  
+          ELSEIF ( INDEX( TRIM( myname ), 'an_' ) /= 0 )  THEN
+             CALL pmci_set_array_pointer( myname, child_id = child_id,         &
+                                          nz_cl = nz_cl, n = ib )
+             ib = ib + 1 
+          ELSEIF ( INDEX( TRIM( myname ), 'am_' ) /= 0 )  THEN
+             CALL pmci_set_array_pointer( myname, child_id = child_id,         &
+                                          nz_cl = nz_cl, n = ic )
+             ic = ic + 1 
+          ELSEIF ( INDEX( TRIM( myname ), 'sg_' ) /= 0  .AND.                  &
+             .NOT. salsa_gases_from_chem )                                     &
+          THEN
+             CALL pmci_set_array_pointer( myname, child_id = child_id,         &
+                                          nz_cl = nz_cl, n = ig )
+             ig = ig + 1
           ELSE
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
@@ -1193,6 +1223,10 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=da_namelen) ::  myname     !< 
-    INTEGER(iwp) ::  ierr       !< MPI error code
+
+    CHARACTER(LEN=da_namelen) ::  myname     !<
+    CHARACTER(LEN=5) ::  salsa_char          !<
+    INTEGER(iwp) ::  ib         !< running index for aerosol size bins
+    INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
+    INTEGER(iwp) ::  ierr       !<
     INTEGER(iwp) ::  icl        !< Left index limit for children's parent-grid arrays
     INTEGER(iwp) ::  icla       !< Left index limit for allocation of index-mapping and other auxiliary arrays
@@ -1201,4 +1235,5 @@
     INTEGER(iwp) ::  icra       !< Right index limit for allocation of index-mapping and other auxiliary arrays
     INTEGER(iwp) ::  icrw       !< Right index limit for children's parent-grid work arrays
+    INTEGER(iwp) ::  ig         !< running index for salsa gases
     INTEGER(iwp) ::  jcn        !< North index limit for children's parent-grid arrays
     INTEGER(iwp) ::  jcna       !< North index limit for allocation of index-mapping and other auxiliary arrays
@@ -1281,9 +1316,44 @@
                                           'chem_' //                           &
                                           TRIM( chem_species(n)%name ),        &
-                                         'fine',                               &
+                                          'fine',                              &
                                           'chem_' //                           &
                                           TRIM( chem_species(n)%name ),        &
                                           ierr )
           ENDDO 
+       ENDIF
+
+       IF ( salsa  .AND.  nest_salsa )  THEN
+          DO  ib = 1, nbins_aerosol
+             WRITE(salsa_char,'(i0)') ib
+             CALL pmc_set_dataarray_name( 'coarse',                            &
+                                          'an_' //                             &
+                                          TRIM( salsa_char ),                  &
+                                          'fine',                              &
+                                          'an_' //                             &
+                                          TRIM( salsa_char ),                  &
+                                          ierr )
+          ENDDO
+          DO  ic = 1, nbins_aerosol * ncomponents_mass
+             WRITE(salsa_char,'(i0)') ic
+             CALL pmc_set_dataarray_name( 'coarse',                            &
+                                          'am_' //                             &
+                                          TRIM( salsa_char ),                  &
+                                          'fine',                              &
+                                          'am_' //                             &
+                                          TRIM( salsa_char ),                  &
+                                          ierr )
+          ENDDO
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                WRITE(salsa_char,'(i0)') ig
+                CALL pmc_set_dataarray_name( 'coarse',                         &
+                                             'sg_' //                          &
+                                             TRIM( salsa_char ),               &
+                                             'fine',                           &
+                                             'sg_' //                          &
+                                             TRIM( salsa_char ),               &
+                                             ierr )
+             ENDDO
+          ENDIF
        ENDIF
 
@@ -1364,5 +1434,9 @@
        CALL  pmc_c_clear_next_array_list
 
-       n = 1
+       ib = 1
+       ic = 1
+       ig = 1
+       n  = 1
+
        DO  WHILE ( pmc_c_getnextarray( myname ) )
 !--       Note that cg%nz is not the original nz of parent, but the highest
@@ -1375,5 +1449,19 @@
           IF ( INDEX( TRIM( myname ), 'chem_' ) /= 0 )  THEN             
              CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz, n )
-             n = n + 1
+             n = n + 1    
+          ELSEIF ( INDEX( TRIM( myname ), 'an_' ) /= 0 )  THEN
+             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
+                                             ib )
+             ib = ib + 1
+          ELSEIF ( INDEX( TRIM( myname ), 'am_' ) /= 0 )  THEN
+             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
+                                             ic )
+             ic = ic + 1
+          ELSEIF ( INDEX( TRIM( myname ), 'sg_' ) /= 0  .AND.                  &
+             .NOT. salsa_gases_from_chem )                                     &
+          THEN
+             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
+                                             ig )
+             ig = ig + 1
           ELSE
              CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz )
@@ -2114,4 +2202,14 @@
     IF ( air_chemistry  .AND.  nest_chemistry )                                &
        pmc_max_array = pmc_max_array + nspec
+!
+!-- Salsa, depens on the number aerosol size bins and chemical components + 
+!-- the number of default gases
+    IF ( salsa  .AND.  nest_salsa )                                            &
+       pmc_max_array = pmc_max_array + nbins_aerosol + nbins_aerosol *         &
+                       ncomponents_mass
+       IF ( .NOT. salsa_gases_from_chem )  pmc_max_array = pmc_max_array +     &
+                                                           ngases_salsa
+
+
 #endif
     
@@ -2126,5 +2224,6 @@
     INTEGER(iwp), INTENT(IN)          ::  child_id    !<
     INTEGER(iwp), INTENT(IN)          ::  nz_cl       !<
-    INTEGER(iwp), INTENT(IN),OPTIONAL ::  n           !< index of chemical species
+    INTEGER(iwp), INTENT(IN),OPTIONAL ::  n           !< index of chemical 
+                                                      !< species / salsa variables
 
     CHARACTER(LEN=*), INTENT(IN) ::  name             !<
@@ -2159,5 +2258,9 @@
     IF ( TRIM(name) == "nr_part"    )  i_2d => nr_part
     IF ( TRIM(name) == "part_adr"   )  i_2d => part_adr
-    IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d => chem_species(n)%conc
+    IF ( INDEX( TRIM(name), "chem_" ) /= 0      )  p_3d => chem_species(n)%conc
+    IF ( INDEX( TRIM(name), "an_" ) /= 0  )  p_3d => aerosol_number(n)%conc
+    IF ( INDEX( TRIM(name), "am_" ) /= 0 )  p_3d => aerosol_mass(n)%conc
+    IF ( INDEX( TRIM(name), "sg_" ) /= 0  .AND.  .NOT. salsa_gases_from_chem ) &
+       p_3d => salsa_gas(n)%conc
 !
 !-- Next line is just an example for a 2D array (not active for coupling!)
@@ -2176,5 +2279,9 @@
     IF ( TRIM(name) == "s"    )  p_3d_sec => s_2
     IF ( TRIM(name) == "diss" )  p_3d_sec => diss_2
-    IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d_sec => spec_conc_2(:,:,:,n)
+    IF ( INDEX( TRIM(name), "chem_" ) /= 0      )  p_3d_sec => spec_conc_2(:,:,:,n)
+    IF ( INDEX( TRIM(name), "an_" ) /= 0  )  p_3d_sec => nconc_2(:,:,:,n)
+    IF ( INDEX( TRIM(name), "am_" ) /= 0 )  p_3d_sec => mconc_2(:,:,:,n)
+    IF ( INDEX( TRIM(name), "sg_" ) /= 0  .AND.  .NOT. salsa_gases_from_chem ) &
+       p_3d_sec => gconc_2(:,:,:,n)
 
     IF ( ASSOCIATED( p_3d ) )  THEN
@@ -2295,5 +2402,6 @@
     INTEGER(iwp), INTENT(IN) ::  nzc     !<  nzc is cg%nz, but note that cg%nz is not the original nz of parent, but the highest parent-grid level needed for nesting.
 
-    INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species
+    INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species /
+                                              !< salsa variables
 
 #if defined( __parallel )
@@ -2356,4 +2464,17 @@
           ALLOCATE( chem_spec_c(0:nzc+1,js:je,is:ie,1:nspec) )
        p_3d => chem_spec_c(:,:,:,n)
+    ELSEIF ( TRIM( name(1:3) ) == "an_" )  THEN
+       IF ( .NOT. ALLOCATED( aerosol_number_c ) )                              &
+          ALLOCATE( aerosol_number_c(0:nzc+1,js:je,is:ie,1:nbins_aerosol) )
+       p_3d => aerosol_number_c(:,:,:,n)
+    ELSEIF ( TRIM( name(1:3) ) == "am_" )  THEN
+       IF ( .NOT. ALLOCATED( aerosol_mass_c ) )                                &
+          ALLOCATE( aerosol_mass_c(0:nzc+1,js:je,is:ie,1:(nbins_aerosol*ncomponents_mass) ) )
+       p_3d => aerosol_mass_c(:,:,:,n)
+    ELSEIF ( TRIM( name(1:3) ) == "sg_"  .AND.  .NOT. salsa_gases_from_chem )  &
+    THEN
+       IF ( .NOT. ALLOCATED( salsa_gas_c ) )                                   &
+          ALLOCATE( salsa_gas_c(0:nzc+1,js:je,is:ie,1:ngases_salsa) )
+       p_3d => salsa_gas_c(:,:,:,n)
     !ELSEIF (trim(name) == "z0") then
        !IF (.not.allocated(z0c))  allocate(z0c(js:je, is:ie))
@@ -2419,4 +2540,6 @@
 
     INTEGER(iwp) ::  i          !<
+    INTEGER(iwp) ::  ib         !< running index for aerosol size bins
+    INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
     INTEGER(iwp) ::  icl        !<
     INTEGER(iwp) ::  icla       !<
@@ -2425,4 +2548,5 @@
     INTEGER(iwp) ::  icra       !<
     INTEGER(iwp) ::  icrw       !<
+    INTEGER(iwp) ::  ig         !< running index for salsa gases
     INTEGER(iwp) ::  j          !<
     INTEGER(iwp) ::  jcn        !<
@@ -2434,4 +2558,5 @@
     INTEGER(iwp) ::  k          !< 
     INTEGER(iwp) ::  n          !< running index for chemical species
+
     REAL(wp) ::  waittime       !<
 
@@ -2502,4 +2627,21 @@
                                          kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
           ENDDO
+       ENDIF
+
+       IF ( salsa  .AND.  nest_salsa )  THEN
+          DO  ib = 1, nbins_aerosol
+             CALL pmci_interp_1sto_all ( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),        &
+                                         kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
+          ENDDO
+          DO  ic = 1, nbins_aerosol * ncomponents_mass
+             CALL pmci_interp_1sto_all ( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),            &
+                                         kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
+          ENDDO
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                CALL pmci_interp_1sto_all ( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),             &
+                                            kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
+             ENDDO
+          ENDIF
        ENDIF
 
@@ -3080,4 +3222,7 @@
        INTEGER(iwp) ::  ibgp       !< index running over the nbgp boundary ghost points in i-direction
        INTEGER(iwp) ::  jbgp       !< index running over the nbgp boundary ghost points in j-direction
+       INTEGER(iwp) ::  ib         !< running index for aerosol size bins
+       INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
+       INTEGER(iwp) ::  ig         !< running index for salsa gases
        INTEGER(iwp) ::  n          !< running index for number of chemical species
       
@@ -3141,4 +3286,21 @@
              ENDIF
 
+             IF ( salsa  .AND.  nest_salsa )  THEN
+                DO  ib = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_lr( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                                             kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
+                ENDDO
+                DO  ic = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_lr( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                                             kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
+                ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  ig = 1, ngases_salsa
+                      CALL pmci_interp_1sto_lr( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                                                kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
+                   ENDDO
+                ENDIF
+             ENDIF
+
           ENDIF
 !
@@ -3195,4 +3357,22 @@
                 ENDDO
              ENDIF
+
+             IF ( salsa  .AND.  nest_salsa )  THEN
+                DO  ib = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_lr( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                                             kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
+                ENDDO
+                DO  ic = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_lr( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                                             kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
+                ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  ig = 1, ngases_salsa
+                      CALL pmci_interp_1sto_lr( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                                                kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
+                   ENDDO
+                ENDIF
+             ENDIF
+
           ENDIF
 !
@@ -3248,4 +3428,22 @@
                 ENDDO
              ENDIF
+             
+             IF ( salsa  .AND.  nest_salsa )  THEN
+                DO  ib = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_sn( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                                             kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
+                ENDDO
+                DO  ic = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_sn( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                                             kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
+                ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  ig = 1, ngases_salsa
+                      CALL pmci_interp_1sto_sn( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                                                kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
+                   ENDDO
+                ENDIF
+             ENDIF
+                       
           ENDIF
 !
@@ -3301,4 +3499,22 @@
                 ENDDO
              ENDIF
+             
+             IF ( salsa  .AND.  nest_salsa )  THEN
+                DO  ib = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_sn( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                                             kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
+                ENDDO
+                DO  ic = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_sn( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                                             kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
+                ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  ig = 1, ngases_salsa
+                      CALL pmci_interp_1sto_sn( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                                                kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
+                   ENDDO
+                ENDIF
+             ENDIF
+                          
           ENDIF
 
@@ -3348,4 +3564,21 @@
                                       kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDDO
+       ENDIF 
+       
+       IF ( salsa  .AND.  nest_salsa )  THEN
+          DO  ib = 1, nbins_aerosol
+             CALL pmci_interp_1sto_t( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),           &
+                                      kcto, iflo, ifuo, jflo, jfuo, 's' )
+          ENDDO
+          DO  ic = 1, nbins_aerosol * ncomponents_mass
+             CALL pmci_interp_1sto_t( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),               &
+                                      kcto, iflo, ifuo, jflo, jfuo, 's' )
+          ENDDO
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                CALL pmci_interp_1sto_t( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),                &
+                                         kcto, iflo, ifuo, jflo, jfuo, 's' )
+             ENDDO
+          ENDIF
        ENDIF
 
@@ -3360,7 +3593,10 @@
 !--   Note that TKE is not anterpolated.
       IMPLICIT NONE
+      INTEGER(iwp) ::  ib         !< running index for aerosol size bins
+      INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
       INTEGER(iwp) ::  n          !< running index for number of chemical species
-
-      
+      INTEGER(iwp) ::  ig         !< running index for salsa gases
+
+
       CALL pmci_anterp_tophat( u,  uc,  kcto, iflu, ifuu, jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
       CALL pmci_anterp_tophat( v,  vc,  kcto, iflo, ifuo, jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
@@ -3419,4 +3655,21 @@
                                      kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
          ENDDO
+      ENDIF
+      
+      IF ( salsa  .AND.  nest_salsa )  THEN
+         DO  ib = 1, nbins_aerosol
+            CALL pmci_anterp_tophat( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),            &
+                                     kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+         ENDDO
+         DO  ic = 1, nbins_aerosol * ncomponents_mass
+            CALL pmci_anterp_tophat( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),                &
+                                     kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+         ENDDO
+         IF ( .NOT. salsa_gases_from_chem )  THEN
+            DO  ig = 1, ngases_salsa
+               CALL pmci_anterp_tophat( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),                 &
+                                        kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+            ENDDO
+         ENDIF
       ENDIF
 
@@ -4275,4 +4528,7 @@
         ONLY:  ibc_pt_b, ibc_q_b, ibc_s_b, ibc_uv_b
 
+    USE salsa_mod,                                                             &
+        ONLY:  ibc_salsa_b
+
     USE surface_mod,                                                           &
         ONLY:  bc_h
@@ -4280,10 +4536,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !< Index along x-direction
-    INTEGER(iwp) ::  j  !< Index along y-direction
-    INTEGER(iwp) ::  k  !< Index along z-direction
-    INTEGER(iwp) ::  m  !< Running index for surface type
-    INTEGER(iwp) ::  n  !< running index for number of chemical species
-    
+    INTEGER(iwp) ::  i   !< Index along x-direction
+    INTEGER(iwp) ::  ib  !< running index for aerosol size bins
+    INTEGER(iwp) ::  ic  !< running index for aerosol mass bins
+    INTEGER(iwp) ::  ig  !< running index for salsa gases
+    INTEGER(iwp) ::  j   !< Index along y-direction
+    INTEGER(iwp) ::  k   !< Index along z-direction
+    INTEGER(iwp) ::  m   !< Running index for surface type
+    INTEGER(iwp) ::  n   !< running index for number of chemical species
+
 !
 !-- Set Dirichlet boundary conditions for horizontal velocity components
@@ -4433,5 +4692,43 @@
           ENDDO
        ENDIF
-    ENDIF
+    ENDIF 
+!
+!-- Set Neumann boundary conditions for aerosols and salsa gases
+    IF ( salsa  .AND.  nest_salsa )  THEN
+       IF ( ibc_salsa_b == 1 )  THEN
+          DO  m = 1, bc_h(0)%ns
+             i = bc_h(0)%i(m)
+             j = bc_h(0)%j(m)
+             k = bc_h(0)%k(m)
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(k-1,j,i) = aerosol_number(ib)%conc(k,j,i)
+             ENDDO
+             DO  ic = 1, nbins_aerosol * ncomponents_mass
+                aerosol_mass(ic)%conc(k-1,j,i) = aerosol_mass(ic)%conc(k,j,i)
+             ENDDO
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  ig = 1, ngases_salsa
+                   salsa_gas(ig)%conc(k-1,j,i) = salsa_gas(ig)%conc(k,j,i)
+                ENDDO
+             ENDIF
+          ENDDO
+          DO  m = 1, bc_h(1)%ns
+             i = bc_h(1)%i(m)
+             j = bc_h(1)%j(m)
+             k = bc_h(1)%k(m)
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(k+1,j,i) = aerosol_number(ib)%conc(k,j,i)
+             ENDDO
+             DO  ic = 1, nbins_aerosol * ncomponents_mass
+                aerosol_mass(ic)%conc(k+1,j,i) = aerosol_mass(ic)%conc(k,j,i)
+             ENDDO
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  ig = 1, ngases_salsa
+                   salsa_gas(ig)%conc(k+1,j,i) = salsa_gas(ig)%conc(k,j,i)
+                ENDDO
+             ENDIF
+          ENDDO
+       ENDIF
+    ENDIF    
 
  END SUBROUTINE pmci_boundary_conds
